#ifndef GLWIN_H
#define GLWIN_H
#include <QOpenGLWidget>
#include <QOpenGLFunctions>

class GLWidget : public QOpenGLWidget, protected QOpenGLFunctions {
    Q_OBJECT
public:
    GLWidget(QWidget* parent);
    ~GLWidget();

    void getColor(GLfloat& red, GLfloat& green, GLfloat& blue);
    GLfloat getXRot() const {return xRot;}
    GLfloat getYRot() const {return yRot;}
    GLfloat getZRot() const {return zRot;}

public slots:
    void setColor(GLfloat red, GLfloat green, GLfloat blue);
    void setXRot(GLfloat angle);
    void setYRot(GLfloat angle);
    void setZRot(GLfloat angle);

signals:
    void colorChanged(GLfloat red, GLfloat green, GLfloat blue);
    void xRotChanged(GLfloat angle);
    void yRotChanged(GLfloat angle);
    void zRotChanged(GLfloat angle);

private:
    GLfloat red, green, blue;
    GLfloat xRot, yRot, zRot;
    void initializeGL();
    void paintGL();
    void resizeGL(int w, int h);
    void draw();
};

#endif // GLWIN_H
